;	@com.wudsn.ide.asm.mainsourcefile=ASpongy.asm

	.proc spongy
banks	= $600	;From ASpongy.bin
sm	= $4000
frame_max = $140

	.proc init
	ldx #0
	ldy #$20
init	cpx #48		;Strech DL
	bcs init1
	lda dl.dl2,x
	sta dl.dl2+2,x
init1	inx
	bne init
	mva #$41 dl.dl_vbl
	mwa #dl dl.dl_vbl+1

	mwa #vbi main.nmi.vbiv
	mwa #dli main.nmi.dliv
	rts
	.endp

	.proc vbi
	lda #$22
	sta $d400
	mwa #dl $d402
	rts
	.endp

	.proc effect

	lda #255
	jsr main.wait
	lda #230
	jsr main.wait

; X=0
mainbank
	ldy #0
	lda banks,y
	bne mainbank1
	sta mainbank+1
	jmp mainbank
mainbank1
	and #$fe
	sta $d301

	lda #3
	jsr main.wait

	lda $d20f
	and #12
	cmp #12
	beq no_key
	lda cnt
	and #3
	bne no_key
	lda wait_mode
	eor #$30
	sta wait_mode
no_key
	lda wait_mode
	sta $d01a
	bne no_count
	inw frame_counter
no_count
	lda frame_counter+1
	cmp #>frame_max
	bne no_return
	lda frame_counter
	cmp #<frame_max
	bne no_return

	lda #$fe
	sta $d301
	lda #0
	sta $d400
	sta $d01a
	mwa #main.nmi.return main.nmi.vbiv
	mwa #main.nmi.return main.nmi.dliv
	rts

no_return
	lda dl.dl1+1
	clc
	adc #$08
mainscreen
	sta dl.dl1+1
	bpl mainbank	;Less than $8000
	inc mainbank+1	;Next bank
	lda #>sm	;Back to $4000
	bne mainscreen

wait_mode	.word 0
frame_counter	 .word 0
	.endp

;------------------------------------------------------------------------------

	.proc dli
	sta $d40a
	lda #13
	sta $d405
	lda #3
	sta $d405
	lda #$40
	sta $d01b

	rts
	.endp

;------------------------------------------------------------------------------
	.align $400
;	2048 bytes = 51 lines with 40 BPL
	.local dl
	.byte $70,$70
	.byte $70+$80
	.byte $6f
dl1	.word sm
dl2	.byte $8f,$2f
dl_vbl	= dl2+48
	.endl
	 
	.endp
